# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`otelcol`](#otelcol)
* [`otelcol::config`](#otelcol--config): == Class: otelcol::config  Templated generation of otelcol.conf
* [`otelcol::install`](#otelcol--install): == Class: otelcol::install  Conditionally handle repos or package paths and install the necessary otelcol package.

#### Private Classes

* `otelcol::service`: Manages the Otelcol service

### Defined types

#### Public Defined types

* [`otelcol::exporter`](#otelcol--exporter): Define a OpenTelemetry Collector exporter
* [`otelcol::extension`](#otelcol--extension): Add an extension to the OpenTelemetry Collector configuration
* [`otelcol::pipeline`](#otelcol--pipeline): Add a pipeline to the OpenTelemetry Collector configuration
* [`otelcol::processor`](#otelcol--processor): Add a processor to the OpenTelemetry Collector configuration
* [`otelcol::receiver`](#otelcol--receiver): Add a receiver to the OpenTelemetry Collector configuration

#### Private Defined types

* `otelcol::component`: Define a component for the OpenTelemetry Collector Configuration

### Data types

* [`Otelcol::Component::Name`](#Otelcol--Component--Name): Type for name of Otel Collector Ressources

## Classes

### <a name="otelcol"></a>`otelcol`

The otelcol class.

#### Parameters

The following parameters are available in the `otelcol` class:

* [`package_name`](#-otelcol--package_name)
* [`package_ensure`](#-otelcol--package_ensure)
* [`service_name`](#-otelcol--service_name)
* [`environment_file`](#-otelcol--environment_file)
* [`run_options`](#-otelcol--run_options)
* [`config_file`](#-otelcol--config_file)
* [`config_file_owner`](#-otelcol--config_file_owner)
* [`config_file_group`](#-otelcol--config_file_group)
* [`config_file_mode`](#-otelcol--config_file_mode)
* [`receivers`](#-otelcol--receivers)
* [`processors`](#-otelcol--processors)
* [`exporters`](#-otelcol--exporters)
* [`pipelines`](#-otelcol--pipelines)
* [`extensions`](#-otelcol--extensions)
* [`log_options`](#-otelcol--log_options)
* [`metrics_level`](#-otelcol--metrics_level)
* [`metrics_address_host`](#-otelcol--metrics_address_host)
* [`metrics_address_port`](#-otelcol--metrics_address_port)
* [`service_ensure`](#-otelcol--service_ensure)
* [`manage_service`](#-otelcol--manage_service)
* [`manage_archive`](#-otelcol--manage_archive)
* [`localpath_archive`](#-otelcol--localpath_archive)
* [`archive_version`](#-otelcol--archive_version)
* [`archive_location`](#-otelcol--archive_location)

##### <a name="-otelcol--package_name"></a>`package_name`

Data type: `String`

Name of the package used

Default value: `'otelcol'`

##### <a name="-otelcol--package_ensure"></a>`package_ensure`

Data type: `Enum['present','absent','installed','latest']`

Ensure for the package

Default value: `'installed'`

##### <a name="-otelcol--service_name"></a>`service_name`

Data type: `String`

Name of the service used

Default value: `$package_name`

##### <a name="-otelcol--environment_file"></a>`environment_file`

Data type: `String`

path of the environment file used for service

Default value: `"/etc/${package_name}/${package_name}.conf"`

##### <a name="-otelcol--run_options"></a>`run_options`

Data type: `Optional[String]`

additional options for service

Default value: `undef`

##### <a name="-otelcol--config_file"></a>`config_file`

Data type: `String`

path to config file

Default value: `"/etc/${package_name}/config.yaml"`

##### <a name="-otelcol--config_file_owner"></a>`config_file_owner`

Data type: `String`

owner of config_file

Default value: `'root'`

##### <a name="-otelcol--config_file_group"></a>`config_file_group`

Data type: `String`

group of config_file

Default value: `'root'`

##### <a name="-otelcol--config_file_mode"></a>`config_file_mode`

Data type: `Stdlib::Filemode`

mode of config_file

Default value: `'0644'`

##### <a name="-otelcol--receivers"></a>`receivers`

Data type: `Hash[String, Hash]`

Hash for receivers config

Default value: `{}`

##### <a name="-otelcol--processors"></a>`processors`

Data type: `Hash[String, Hash]`

Hash for processors config

Default value: `{}`

##### <a name="-otelcol--exporters"></a>`exporters`

Data type: `Hash[String, Hash]`

Hash for exporters config

Default value: `{}`

##### <a name="-otelcol--pipelines"></a>`pipelines`

Data type: `Hash[String, Hash]`

Hash for pipelines config

Default value: `{}`

##### <a name="-otelcol--extensions"></a>`extensions`

Data type: `Hash[String, Hash]`

Hash for extensions config

Default value: `{}`

##### <a name="-otelcol--log_options"></a>`log_options`

Data type: `Variant[Hash,String[1]]`

Hash for log_options config

Default value: `{}`

##### <a name="-otelcol--metrics_level"></a>`metrics_level`

Data type: `Enum['none','basic','normal','detailed']`

Level for metrics config

Default value: `'basic'`

##### <a name="-otelcol--metrics_address_host"></a>`metrics_address_host`

Data type: `Optional[Stdlib::Host]`

Host metrics are listening to

Default value: `undef`

##### <a name="-otelcol--metrics_address_port"></a>`metrics_address_port`

Data type: `Stdlib::Port`

Port metrics are listening to

Default value: `8888`

##### <a name="-otelcol--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Ensure for service

Default value: `'running'`

##### <a name="-otelcol--manage_service"></a>`manage_service`

Data type: `Boolean`

If service is managed by module

Default value: `true`

##### <a name="-otelcol--manage_archive"></a>`manage_archive`

Data type: `Boolean`

If archive should be managed by module of will be provided by packagemanager

Default value: `false`

##### <a name="-otelcol--localpath_archive"></a>`localpath_archive`

Data type: `String[1]`

Path where archive will be stored if managed

Default value: `'/tmp'`

##### <a name="-otelcol--archive_version"></a>`archive_version`

Data type: `String[1]`

Version of otelcol that will be used, param is not used if archive_location is set

Default value: `'0.89.0'`

##### <a name="-otelcol--archive_location"></a>`archive_location`

Data type: `String[1]`

Path to archive without filetype extension

Default value: `"https://github.com/open-telemetry/opentelemetry-collector-releases/releases/download/v${archive_version}/${package_name}_${archive_version}_linux_amd64"`

### <a name="otelcol--config"></a>`otelcol::config`

== Class: otelcol::config

Templated generation of otelcol.conf

### <a name="otelcol--install"></a>`otelcol::install`

== Class: otelcol::install

Conditionally handle repos or package paths and install the necessary
otelcol package.

## Defined types

### <a name="otelcol--exporter"></a>`otelcol::exporter`

Create a OpenTelemetry Collector exporter in the configuration file.

#### Examples

##### Basic usage

```puppet
otelcol::exporter { 'namevar': }
```

##### Define a exporter and attach it to a pipeline

```puppet
otelcol::exporter { 'prometheus':
  pipelines => ['metrics'],
}
```

#### Parameters

The following parameters are available in the `otelcol::exporter` defined type:

* [`name`](#-otelcol--exporter--name)
* [`config`](#-otelcol--exporter--config)
* [`order`](#-otelcol--exporter--order)
* [`pipelines`](#-otelcol--exporter--pipelines)

##### <a name="-otelcol--exporter--name"></a>`name`

The name of the exporter.

##### <a name="-otelcol--exporter--config"></a>`config`

Data type: `Hash`

The configuration of the exporter.

Default value: `{}`

##### <a name="-otelcol--exporter--order"></a>`order`

Data type: `Integer[0,999]`

The order of the exporter.

Default value: `0`

##### <a name="-otelcol--exporter--pipelines"></a>`pipelines`

Data type: `Array[String[1]]`

The pipelines to attach the exporter to.

Default value: `[]`

### <a name="otelcol--extension"></a>`otelcol::extension`

Add an extension to the OpenTelemetry Collector configuration

#### Examples

##### Basic usage

```puppet
otelcol::extension { 'namevar': }
```

#### Parameters

The following parameters are available in the `otelcol::extension` defined type:

* [`name`](#-otelcol--extension--name)
* [`config`](#-otelcol--extension--config)
* [`order`](#-otelcol--extension--order)

##### <a name="-otelcol--extension--name"></a>`name`

The name of the extension

##### <a name="-otelcol--extension--config"></a>`config`

Data type: `Hash`

The configuration for the extension

Default value: `{}`

##### <a name="-otelcol--extension--order"></a>`order`

Data type: `Integer[0,999]`

The order in which the extension should be loaded

Default value: `0`

### <a name="otelcol--pipeline"></a>`otelcol::pipeline`

Used for explicitly configuring a pipeline in the OpenTelemetry Collector.
This is useful for configuring a pipeline that is not automatically
configured by its Components.

#### Examples

##### Configure a pipeline

```puppet
otelcol::pipeline { 'namevar': }
```

#### Parameters

The following parameters are available in the `otelcol::pipeline` defined type:

* [`name`](#-otelcol--pipeline--name)
* [`config`](#-otelcol--pipeline--config)
* [`order`](#-otelcol--pipeline--order)

##### <a name="-otelcol--pipeline--name"></a>`name`

The name of the pipeline to configure.

##### <a name="-otelcol--pipeline--config"></a>`config`

Data type: `Hash`

The configuration for the pipeline.

Default value: `{}`

##### <a name="-otelcol--pipeline--order"></a>`order`

Data type: `Integer[0,999]`

The order in which the pipeline should be configured.

Default value: `0`

### <a name="otelcol--processor"></a>`otelcol::processor`

Add a processor to the OpenTelemetry Collector configuration

#### Examples

##### Basic usage

```puppet
otelcol::processor { 'namevar': }
```

##### Define a processor and attach it to a pipeline

```puppet
otelcol::processor { 'batch':
  pipelines => ['metrics'],
}
```

#### Parameters

The following parameters are available in the `otelcol::processor` defined type:

* [`name`](#-otelcol--processor--name)
* [`config`](#-otelcol--processor--config)
* [`order`](#-otelcol--processor--order)
* [`pipelines`](#-otelcol--processor--pipelines)

##### <a name="-otelcol--processor--name"></a>`name`

The name of the processor

##### <a name="-otelcol--processor--config"></a>`config`

Data type: `Hash`

The configuration of the processor

Default value: `{}`

##### <a name="-otelcol--processor--order"></a>`order`

Data type: `Integer[0,999]`

The order of the processor

Default value: `0`

##### <a name="-otelcol--processor--pipelines"></a>`pipelines`

Data type: `Array[String[1]]`

The pipelines to attach the processor to

Default value: `[]`

### <a name="otelcol--receiver"></a>`otelcol::receiver`

Add a receiver to the OpenTelemetry Collector configuration

#### Examples

##### basic receiver

```puppet
otelcol::receiver { 'namevar': }
```

##### Define a receiver and attach it to a pipeline

```puppet
otelcol::receiver { 'otlp':
  pipelines => ['metrics'],
}
```

#### Parameters

The following parameters are available in the `otelcol::receiver` defined type:

* [`name`](#-otelcol--receiver--name)
* [`config`](#-otelcol--receiver--config)
* [`order`](#-otelcol--receiver--order)
* [`pipelines`](#-otelcol--receiver--pipelines)

##### <a name="-otelcol--receiver--name"></a>`name`

The name of the receiver

##### <a name="-otelcol--receiver--config"></a>`config`

Data type: `Hash`

The configuration of the receiver

Default value: `{}`

##### <a name="-otelcol--receiver--order"></a>`order`

Data type: `Integer[0,999]`

The order of the receiver

Default value: `0`

##### <a name="-otelcol--receiver--pipelines"></a>`pipelines`

Data type: `Array[String[1]]`

The pipelines the receiver is part of

Default value: `[]`

## Data types

### <a name="Otelcol--Component--Name"></a>`Otelcol::Component::Name`

Type for name of Otel Collector Ressources

Alias of `Pattern[/\A[a-z0-9_-]+(\/[a-z0-9]+)?\z/]`

